# -*- coding: utf-8 -*-
"""
    Various function common to all Ekd modules
"""

from moteur_modules_common.EkdConfig import EkdConfig
from PyQt4.QtCore import QString
###############
from moteur_modules_common.EkdCompatiblePython2Et3 import EkdPrintConfig
###############


def debug( message ):
    """
        Affiche un message de sur la console en fonction du codage de la machine
    """
    EkdPrintConfig("Debug:: %s" % message)

def concat_files(files, output):
    """ Concatenat files into output"""
    foutput = open(output, 'wb+')
    for fd in files:
        input = open(fd, 'rb')
        # We read chunks of 1Mb from input and write it to output
        buff = input.read(1024 * 1024)
        while buff:
            foutput.write(buff)
            buff = input.read(1024 * 1024)
        input.close()
    foutput.flush()
    foutput.close()
